require 'spec_helper'

type_class = Puppet::Type.type(:groupmembership)
provider_class = type_class.provider(:gpasswd)

describe provider_class do
  context "#members=" do
    context "on Linux" do
      #let(:facts) { {:kernel => 'Linux'} }
      let(:provider) { provider_class }

      before do
        allow(provider).to receive(:command).with(:gpasswd).and_return('/usr/bin/gpasswd')
      end

      context "when multiple members are present" do
        let!(:info) { "wheel:*:0:root,foo,bar" }

        before do
          expect(resource.provider).to receive(:getent_group) { info }
        end

        context "when exclusive is not set" do
          let!(:resource) { Puppet::Type.type(:groupmembership).new(
              :name => 'wheel',
              :provider => 'gpasswd',
              :members => ['root'],
              :exclusive => :false,
          ) }

          it 'should set membership to the specified users' do
            expect(resource.provider.members=(['root'])).to receive(:execute).with(['/usr/bin/gpasswd', '-m', 'root', 'wheel'])
          end
        end

      end

    end
  end
end
